SoulstoneWatcherConfig = {}

local SPELL_ID = 5232
local localizedClass, englishClass, classIndex = UnitClass("player")
local button1Player;
local button2Player;
local button3Player;
local button4Player;
local castID;
local castTargetPlayer;
local f

local function start_loading(self, event)
    load_options()
end

local function set_option_message_to_raid(self, option, check)
    if SoulstoneWatcherConfig.say_to_raid == true then
        SoulstoneWatcherConfig.say_to_raid = false
        return
    end
    if SoulstoneWatcherConfig.say_to_raid == false or SoulstoneWatcherConfig.say_to_raid == nil then
        SoulstoneWatcherConfig.say_to_raid = true
        return
    end
end

local function set_option_message_to_party(self, option, check)
    if SoulstoneWatcherConfig.say_to_party == true then
        SoulstoneWatcherConfig.say_to_party = false
        return
    end
    if SoulstoneWatcherConfig.say_to_party == false or SoulstoneWatcherConfig.say_to_party == nil then
        SoulstoneWatcherConfig.say_to_party = true
        return
    end
end

local function set_option_enable_at_ready(self, option, check)
    if SoulstoneWatcherConfig.enable_at_ready == true then
        SoulstoneWatcherConfig.enable_at_ready = false
        return
    end
    if SoulstoneWatcherConfig.enable_at_ready == false or SoulstoneWatcherConfig.enable_at_ready == nil then
        SoulstoneWatcherConfig.enable_at_ready = true
        return
    end
end

local function set_option_enable_at_join(self, option, check)
    if SoulstoneWatcherConfig.enable_at_join == true then
        SoulstoneWatcherConfig.enable_at_join = false
        return
    end
    if SoulstoneWatcherConfig.enable_at_join == false or SoulstoneWatcherConfig.enable_at_join == nil then
        SoulstoneWatcherConfig.enable_at_join = true
        return
    end
end

local SoulstoneWatcherOptions = {};
SoulstoneWatcherOptions.panel = CreateFrame( "Frame", "Soulstone Watcher", UIParent );
SoulstoneWatcherOptions.panel.name = "Soulstone Watcher";
InterfaceOptions_AddCategory(SoulstoneWatcherOptions.panel);

local markerOptionsText = SoulstoneWatcherOptions.panel:CreateFontString("markerOptionsText", "OVERLAY", "GameFontNormalLarge")
markerOptionsText:SetPoint("TOP", SoulstoneWatcherOptions.panel, "TOP",0,-10)
markerOptionsText:SetText("|cff8788EESoulstone Watcher Options")

local markerOptionsTextRaid = SoulstoneWatcherOptions.panel:CreateFontString("markerOptionsTextRaid", "OVERLAY", "GameFontNormal")
markerOptionsTextRaid:SetPoint("TOPLEFT", SoulstoneWatcherOptions.panel, "TOPLEFT",10,-30)
markerOptionsTextRaid:SetText("Enable at (changes take effect after reload)")

local enableCheckBoxReady = CreateFrame("CheckButton", "enableCheckBoxReady", SoulstoneWatcherOptions.panel, "UICheckButtonTemplate")
enableCheckBoxReady:SetPoint("TOPLEFT", SoulstoneWatcherOptions.panel, "TOPLEFT",25, -50)
enableCheckBoxReady:SetSize(20,20)
enableCheckBoxReady:SetScript("OnClick", set_option_enable_at_ready)

local enableCheckBoxReadyText = SoulstoneWatcherOptions.panel:CreateFontString("enableCheckBoxReadyText", "OVERLAY", "GameFontWhite")
enableCheckBoxReadyText:SetPoint("LEFT", enableCheckBoxReady, "RIGHT", 5, 0)
enableCheckBoxReadyText:SetText("Enable check at ReadyCheck")

local enableCheckBoxJoin = CreateFrame("CheckButton", "enableCheckBoxJoin", SoulstoneWatcherOptions.panel, "UICheckButtonTemplate")
enableCheckBoxJoin:SetPoint("TOPLEFT", SoulstoneWatcherOptions.panel, "TOPLEFT",25, -70)
enableCheckBoxJoin:SetSize(20,20)
enableCheckBoxJoin:SetScript("OnClick", set_option_enable_at_join)

local enableCheckBoxJoinText = SoulstoneWatcherOptions.panel:CreateFontString("enableCheckBoxJoinText", "OVERLAY", "GameFontWhite")
enableCheckBoxJoinText:SetPoint("LEFT", enableCheckBoxJoin, "RIGHT", 5, 0)
enableCheckBoxJoinText:SetText("Enable check when joining a group")

local markerOptionsTextMessage = SoulstoneWatcherOptions.panel:CreateFontString("markerOptionsTextMessage", "OVERLAY", "GameFontNormal")
markerOptionsTextMessage:SetPoint("TOPLEFT", SoulstoneWatcherOptions.panel, "TOPLEFT",10,-110)
markerOptionsTextMessage:SetText("Cast Messages")

local messageCheckBoxRaid = CreateFrame("CheckButton", "messageCheckBoxRaid", SoulstoneWatcherOptions.panel, "UICheckButtonTemplate")
messageCheckBoxRaid:SetPoint("TOPLEFT", SoulstoneWatcherOptions.panel, "TOPLEFT",25, -130)
messageCheckBoxRaid:SetSize(20,20)
messageCheckBoxRaid:SetScript("OnClick", set_option_message_to_raid)

local messageCheckBoxRaidText = SoulstoneWatcherOptions.panel:CreateFontString("messageCheckBoxRaidText", "OVERLAY", "GameFontWhite")
messageCheckBoxRaidText:SetPoint("LEFT", messageCheckBoxRaid, "RIGHT", 5, 0)
messageCheckBoxRaidText:SetText("Send cast message to Raid")

local messageCheckBoxParty = CreateFrame("CheckButton", "messageCheckBoxParty", SoulstoneWatcherOptions.panel, "UICheckButtonTemplate")
messageCheckBoxParty:SetPoint("TOPLEFT", SoulstoneWatcherOptions.panel, "TOPLEFT",25, -150)
messageCheckBoxParty:SetSize(20,20)
messageCheckBoxParty:SetScript("OnClick", set_option_message_to_party)

local messageCheckBoxPartyText = SoulstoneWatcherOptions.panel:CreateFontString("messageCheckBoxParty", "OVERLAY", "GameFontWhite")
messageCheckBoxPartyText:SetPoint("LEFT", messageCheckBoxParty, "RIGHT", 5, 0)
messageCheckBoxPartyText:SetText("Send cast message to Party")


local markerOptionsTextTarget = SoulstoneWatcherOptions.panel:CreateFontString("markerOptionsTextTarget", "OVERLAY", "GameFontNormal")
markerOptionsTextTarget:SetPoint("TOPLEFT", SoulstoneWatcherOptions.panel, "TOPLEFT",10,-190)
markerOptionsTextTarget:SetText("Soulstone Main Target")

local dropDownRaid = CreateFrame("Frame", "WPDemoDropDown", SoulstoneWatcherOptions.panel, "UIDropDownMenuTemplate")
dropDownRaid:SetPoint("TOPLEFT", SoulstoneWatcherOptions.panel, "TOPLEFT", 0, -210)
UIDropDownMenu_SetWidth(dropDownRaid, 80)
UIDropDownMenu_Initialize(dropDownRaid, WPDropDownDemo_Menu)
UIDropDownMenu_Initialize(dropDownRaid, function(self)
    local info = UIDropDownMenu_CreateInfo()
    info.func = self.MinorSoulstone
    info.text = "Minor Soulstone"
    UIDropDownMenu_AddButton(info)
    info.func = self.LesserSoulstone
    info.text = "Lesser Soulstone"
    UIDropDownMenu_AddButton(info)
    info.func = self.Soulstone
    info.text = "Soulstone"
    UIDropDownMenu_AddButton(info)
    info.func = self.GreaterSoulstone
    info.text = "Greater Soulstone"
    UIDropDownMenu_AddButton(info)
    info.func = self.MajorSoulstone
    info.text = "Major Soulstone"
    UIDropDownMenu_AddButton(info)
    info.func = self.MasterSoulstone
    info.text = "Master Soulstone"
    UIDropDownMenu_AddButton(info)
end)

local dropDownRaidText = SoulstoneWatcherOptions.panel:CreateFontString("dropDownRaidText", "OVERLAY", "GameFontWhite")
dropDownRaidText:SetPoint("LEFT", dropDownRaid, "RIGHT", 1,0)
dropDownRaidText:SetText("Select soulstone item (rank) for the cast bars.")

local castButton1 = CreateFrame("Button", "myButton", UIParent, "SecureActionButtonTemplate,UIPanelButtonTemplate")
castButton1:SetPoint("CENTER", 0, 100)
castButton1:SetSize(100, 40)
castButton1:SetAttribute("type", "item")
castButton1:Hide()

local castButton2 = CreateFrame("Button", "myButton", UIParent, "SecureActionButtonTemplate,UIPanelButtonTemplate")
castButton2:SetPoint("CENTER", 0, 60)
castButton2:SetSize(100, 40)
castButton2:SetAttribute("type", "item")
castButton2:Hide()

local castButton3 = CreateFrame("Button", "myButton", UIParent, "SecureActionButtonTemplate,UIPanelButtonTemplate")
castButton3:SetPoint("CENTER", 150, 100)
castButton3:SetSize(100, 40)
castButton3:SetAttribute("type", "item")
castButton3:Hide()

local castButton4 = CreateFrame("Button", "myButton", UIParent, "SecureActionButtonTemplate,UIPanelButtonTemplate")
castButton4:SetPoint("CENTER", 150, 60)
castButton4:SetSize(100, 40)
castButton4:SetAttribute("type", "item")
castButton4:Hide()

local castButtonClear = CreateFrame("Button", "myButton", UIParent, "SecureActionButtonTemplate,UIPanelButtonTemplate")
castButtonClear:SetPoint("CENTER", 75, 20)
castButtonClear:SetSize(100, 40)
castButtonClear:SetText("Hide Buttons")
castButtonClear:SetScript("OnClick", function(self, arg1)
    castButton1:Hide()
    castButton2:Hide()
    castButton3:Hide()
    castButton4:Hide()
    castButtonClear:Hide()
end)
castButtonClear:Hide()

function dropDownRaid:MinorSoulstone()
    UIDropDownMenu_SetText(dropDownRaid, "Minor Soulstone")
    SoulstoneWatcherConfig.soulstone_itemid = 5232
    SPELL_ID = 20707
    castButton1:SetAttribute("item", "item:5232")
    castButton2:SetAttribute("item", "item:5232")
    castButton3:SetAttribute("item", "item:5232")
    castButton4:SetAttribute("item", "item:5232")
    CloseDropDownMenus()
end

function dropDownRaid:LesserSoulstone()
    UIDropDownMenu_SetText(dropDownRaid, "Lesser Soulstone")
    SoulstoneWatcherConfig.soulstone_itemid = 16892
    SPELL_ID = 20762
    castButton1:SetAttribute("item", "item:16892")
    castButton2:SetAttribute("item", "item:16892")
    castButton3:SetAttribute("item", "item:16892")
    castButton4:SetAttribute("item", "item:16892")
    CloseDropDownMenus()
end

function dropDownRaid:Soulstone()
    UIDropDownMenu_SetText(dropDownRaid, "Soulstone")
    SoulstoneWatcherConfig.soulstone_itemid = 16893
    SPELL_ID = 20763
    castButton1:SetAttribute("item", "item:16893")
    castButton2:SetAttribute("item", "item:16893")
    castButton3:SetAttribute("item", "item:16893")
    castButton4:SetAttribute("item", "item:16893")
    CloseDropDownMenus()
end

function dropDownRaid:GreaterSoulstone()
    UIDropDownMenu_SetText(dropDownRaid, "Greater Soulstone")
    SoulstoneWatcherConfig.soulstone_itemid = 16895
    SPELL_ID = 20764
    castButton1:SetAttribute("item", "item:16895")
    castButton2:SetAttribute("item", "item:16895")
    castButton3:SetAttribute("item", "item:16895")
    castButton4:SetAttribute("item", "item:16895")
    CloseDropDownMenus()
end

function dropDownRaid:MajorSoulstone()
    UIDropDownMenu_SetText(dropDownRaid, "Major Soulstone")
    SoulstoneWatcherConfig.soulstone_itemid = 16896
    SPELL_ID = 20765
    castButton1:SetAttribute("item", "item:16896")
    castButton2:SetAttribute("item", "item:16896")
    castButton3:SetAttribute("item", "item:16896")
    castButton4:SetAttribute("item", "item:16896")
    CloseDropDownMenus()
end

function dropDownRaid:MasterSoulstone()
    UIDropDownMenu_SetText(dropDownRaid, "Master Soulstone")
    SoulstoneWatcherConfig.soulstone_itemid = 22116
    SPELL_ID = 27239
    castButton1:SetAttribute("item", "item:22116")
    castButton2:SetAttribute("item", "item:22116")
    castButton3:SetAttribute("item", "item:22116")
    castButton4:SetAttribute("item", "item:22116")
    CloseDropDownMenus()
end

local frame = CreateFrame("FRAME");
frame:RegisterEvent("VARIABLES_LOADED");
frame:SetScript("OnEvent", start_loading)

local function get_player_buffs(player)
    buffList = {}
    button1Player = nil
    button2Player = nil
    button3Player = nil
    button4Player = nil

    for index, playerName in ipairs(player) do
        if index == 1 then
            button1Player = playerName
        end
        if index == 2 then
            button2Player = playerName
        end
        if index == 3 then
            button3Player = playerName
        end
        if index == 4 then
            button4Player = playerName
        end
    end

    if classIndex == 9 then

        if button1Player ~= nil then
            castButton1:SetText(button1Player)
            castButton1:SetAttribute("unit", button1Player) 
            castButton1:Show()
            castButtonClear:Show()
        end

        if button2Player ~= nil then
            castButton2:SetText(button2Player)
            castButton2:SetAttribute("unit", button2Player) 
            castButton2:Show()
            castButtonClear:Show()
        end

        if button3Player ~= nil then
            castButton3:SetText(button3Player)
            castButton3:SetAttribute("unit", button3Player) 
            castButton3:Show()
            castButtonClear:Show()
        end

        if button4Player ~= nil then
            castButton4:SetText(button4Player)
            castButton4:SetAttribute("unit", button4Player) 
            castButton4:Show()
            castButtonClear:Show()
        end
    end
end

local function get_raid_players()
    raidPlayerList = {}
    for i=1,MAX_RAID_MEMBERS do
        name = GetRaidRosterInfo(i)
        table.insert( raidPlayerList, name )
    end
    return raidPlayerList
end

local function OnEvent(self, event)
    startTime, duration, enable = GetItemCooldown(5232)

    if duration == 0 and classIndex == 9 then
        print("|cff8788EESoulstone Watcher: Your Soulstone is ready")
        player = get_raid_players()
        check = get_player_buffs(player)
    end
end

function load_options(self, event)
    if SoulstoneWatcherConfig.enable_at_ready == nil then
        SoulstoneWatcherConfig.enable_at_ready = true
    end

    if SoulstoneWatcherConfig.enable_at_ready == true then
        enableCheckBoxReady:SetChecked(true)
    end

    if SoulstoneWatcherConfig.enable_at_ready == false then
        enableCheckBoxReady:SetChecked(false)
    end

    if SoulstoneWatcherConfig.enable_at_join == nil then
        SoulstoneWatcherConfig.enable_at_join = true
    end

    if SoulstoneWatcherConfig.enable_at_join == true then
        enableCheckBoxJoin:SetChecked(true)
    end

    if SoulstoneWatcherConfig.enable_at_join == false then
        enableCheckBoxJoin:SetChecked(false)
    end

    if SoulstoneWatcherConfig.say_to_raid == nil then
        SoulstoneWatcherConfig.say_to_raid = true
    end

    if SoulstoneWatcherConfig.say_to_raid == true then
        messageCheckBoxRaid:SetChecked(true)
    end

    if SoulstoneWatcherConfig.say_to_raid == false then
        messageCheckBoxRaid:SetChecked(false)
    end

    if SoulstoneWatcherConfig.say_to_party == nil then
        SoulstoneWatcherConfig.say_to_party = true
    end
    if SoulstoneWatcherConfig.say_to_party == true then
        messageCheckBoxParty:SetChecked(true)
    end
    if SoulstoneWatcherConfig.say_to_party == false then
        messageCheckBoxParty:SetChecked(false)
    end

    if SoulstoneWatcherConfig.soulstone_itemid == nil then
        SoulstoneWatcherConfig.soulstone_itemid = 22116
    end

    if SoulstoneWatcherConfig.soulstone_itemid == 5232 then
        UIDropDownMenu_SetText(dropDownRaid, "Minor Soulstone")
        SPELL_ID = 20707
        castButton1:SetAttribute("item", "item:5232")
        castButton2:SetAttribute("item", "item:5232")
        castButton3:SetAttribute("item", "item:5232")
        castButton4:SetAttribute("item", "item:5232")
    end

    if SoulstoneWatcherConfig.soulstone_itemid == 16892 then
        UIDropDownMenu_SetText(dropDownRaid, "Lesser Soulstone")
        SPELL_ID = 20762
        castButton1:SetAttribute("item", "item:16892")
        castButton2:SetAttribute("item", "item:16892")
        castButton3:SetAttribute("item", "item:16892")
        castButton4:SetAttribute("item", "item:16892")
    end

    if SoulstoneWatcherConfig.soulstone_itemid == 16893 then
        UIDropDownMenu_SetText(dropDownRaid, "Soulstone")
        SPELL_ID = 20763
        castButton1:SetAttribute("item", "item:16893")
        castButton2:SetAttribute("item", "item:16893")
        castButton3:SetAttribute("item", "item:16893")
        castButton4:SetAttribute("item", "item:16893")
    end

    if SoulstoneWatcherConfig.soulstone_itemid == 16895 then
        UIDropDownMenu_SetText(dropDownRaid, "Greater Soulstone")
        SPELL_ID = 20764
        castButton1:SetAttribute("item", "item:16895")
        castButton2:SetAttribute("item", "item:16895")
        castButton3:SetAttribute("item", "item:16895")
        castButton4:SetAttribute("item", "item:16895")
    end

    if SoulstoneWatcherConfig.soulstone_itemid == 16896 then
        UIDropDownMenu_SetText(dropDownRaid, "Major Soulstone")
        SPELL_ID = 20765
        castButton1:SetAttribute("item", "item:16896")
        castButton2:SetAttribute("item", "item:16896")
        castButton3:SetAttribute("item", "item:16896")
        castButton4:SetAttribute("item", "item:16896")
    end


    if SoulstoneWatcherConfig.soulstone_itemid == 22116 then
        UIDropDownMenu_SetText(dropDownRaid, "Master Soulstone")
        SPELL_ID = 27239
        castButton1:SetAttribute("item", "item:22116")
        castButton2:SetAttribute("item", "item:22116")
        castButton3:SetAttribute("item", "item:22116")
        castButton4:SetAttribute("item", "item:22116")
    end

    triggerEventFrame = CreateFrame("Frame")

    if SoulstoneWatcherConfig.enable_at_ready == nil then
        SoulstoneWatcherConfig.enable_at_ready = true
    end
    if SoulstoneWatcherConfig.enable_at_ready == true then
        triggerEventFrame:RegisterEvent("READY_CHECK")
    end
    if SoulstoneWatcherConfig.enable_at_join == nil then
        SoulstoneWatcherConfig.enable_at_join = true
    end 
    if SoulstoneWatcherConfig.enable_at_join == true then
        triggerEventFrame:RegisterEvent("GROUP_JOINED")
    end

    triggerEventFrame:SetScript("OnEvent", OnEvent)
end

if classIndex == 9 then
    local spellEventFrame = CreateFrame("Frame")
    spellEventFrame:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
    spellEventFrame:RegisterEvent("UNIT_SPELLCAST_SENT")
    spellEventFrame:SetScript("OnEvent", function(self, event, arg1, arg2, arg3)
                if (event == "UNIT_SPELLCAST_SENT" and arg1 == "player") then
                    castID = arg3;
                    castTargetPlayer = arg2;
                elseif (event == "UNIT_SPELLCAST_SUCCEEDED" and arg2 == castID and arg1 == "player") and (arg3 == 20707 or arg3 == 20762 or arg3 == 20763 or arg3 == 20764 or arg3 == 20765 or arg3 == 27239)  then
                    print("|cff8788EESoulstone Watcher: Casted Soulstone on "..castTargetPlayer)
                    castButton1:Hide()
                    castButton2:Hide()
                    castButton3:Hide()
                    castButton4:Hide()
                    castButtonClear:Hide()
                    if SoulstoneWatcherConfig.say_to_raid == true and UnitInRaid("player") ~= nil then
                        SendChatMessage("Casted Soulstone on "..castTargetPlayer, "RAID")
                        return
                    end
                    if SoulstoneWatcherConfig.say_to_party == true and UnitInParty("player") ~= nil then
                        SendChatMessage("Casted Soulstone on "..castTargetPlayer, "PARTY")
                        return
                    end
                end
    end)
end
